"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var FieldNullability;
(function (FieldNullability) {
    function any(nullable) {
        return { kind: 'Any', nullable };
    }
    FieldNullability.any = any;
    function array(nullable, elemNullable) {
        return { kind: 'Array', nullable, elemNullable };
    }
    FieldNullability.array = array;
    function walk(nullability, handlers) {
        switch (nullability.kind) {
            case 'Any':
                return handlers.any(nullability);
            case 'Array':
                return handlers.array(nullability);
        }
    }
    FieldNullability.walk = walk;
    FieldNullability.disjunction = (a) => (b) => walk(a, {
        any: aAny => walk(b, {
            any: bAny => any(aAny.nullable || bAny.nullable),
            array: bArray => any(aAny.nullable || bArray.nullable),
        }),
        array: aArray => walk(b, {
            any: bAny => any(aArray.nullable || bAny.nullable),
            array: bArray => array(aArray.nullable || bArray.nullable, aArray.elemNullable || bArray.elemNullable),
        }),
    });
})(FieldNullability = exports.FieldNullability || (exports.FieldNullability = {}));
